/*　Ver　2024/07/16
    ************************************************************** 
    *        SWR & POWER meter on 4x20 char LCD display          *
    *                  By JA7FVT  2024                           *
    ************************************************************** 

 * LCD RS pin to digital pin 7
 * LCD Enable pin to digital pin 8
 * LCD D4 pin to digital pin 9
 * LCD D5 pin to digital pin 10
 * LCD D6 pin to digital pin 11
 * LCD D7 pin to digital pin 12
 * LCD R/W pin to ground
 * GND to LCD VO pin (pin 3) (contrast)
 * pin A0 : SWR probe FWD voltage input
 * pin A1 : SWR probe REF voltage input
 * pin D3 : BandSwitch push button switch band change
 * pin D6 : DispSwitch push button switch disp change
*/

float forward_voltage = 0;     
float reflected_voltage = 0; 
float Swr_Calc = 0;
float SwrData = 0;     
float Swr = 0;  
float count = 0;
float Freq_D= 0;  
char FF=255;
int All_power = 0;
int Adj_forward_power = 0;
int forward_power = 0;
int reflected_power = 0;
int ant_power = 0;
int Eef_Calc = 0;
int DispMode = 0;
int ButonPush = 0;

int correct_Power(int forward_power) { 
if(forward_power <= 1.00) forward_power += 0.00;
else if((forward_power > 1.11) && (forward_power <= 4.50)) forward_power += 3.00;
else if((forward_power > 4.51) && (forward_power <= 9.50)) forward_power += 4.20; 
else if((forward_power > 9.51) && (forward_power <= 14.50)) forward_power += 4.20; 
else if((forward_power > 14.51) && (forward_power <= 19.50)) forward_power += 4.10;
else if((forward_power > 19.51) && (forward_power <= 24.50)) forward_power += 4.00; 
else if((forward_power > 24.51) && (forward_power <= 29.50)) forward_power += 4.70; 
else if((forward_power > 29.51) && (forward_power <= 34.50)) forward_power += 5.40; 
else if((forward_power > 34.51) && (forward_power <= 39.50)) forward_power += 5.10; 
else if((forward_power > 39.51) && (forward_power <= 44.50)) forward_power += 4.80; 
else if((forward_power > 44.51) && (forward_power <= 49.50)) forward_power += 3.80; 
else if((forward_power > 49.51) && (forward_power <= 54.50)) forward_power += 4.60; 
else if((forward_power > 54.51) && (forward_power <= 59.50)) forward_power += 3.60; 
else if((forward_power > 59.51) && (forward_power <= 64.50)) forward_power += 6.60; 
else if((forward_power > 64.51) && (forward_power <= 69.50)) forward_power += 6.60; 
else if((forward_power > 69.51) && (forward_power <= 74.50)) forward_power += 5.60; 
else if((forward_power > 74.51) && (forward_power <= 79.50)) forward_power += 4.50; 
else if((forward_power > 79.51) && (forward_power <= 84.50)) forward_power += 3.40; 
else if((forward_power > 84.51) && (forward_power <= 89.50)) forward_power += 3.00; 
else if((forward_power > 89.51) && (forward_power <= 94.50)) forward_power += 0.60; 
else if((forward_power > 94.51) && (forward_power <= 99.50)) forward_power += 1.55; 
else if((forward_power > 99.51) && (forward_power <= 104.50)) forward_power -= 0.50; 
return forward_power;
}

#define ForwCalHF        (100)     // HF band
#define ForwCal19MHz     (110.6)   // 1.8M band
#define ForwCal35MHz     (103.7)   // 3.5M band
#define ForwCal7MHz      (100.0)   // 7.0M band
#define ForwCal10MHz     (100.2)   // 10M band
#define ForwCal14MHz     (100.3)   // 14M band
#define ForwCal18MHz     (100.7)   // 18M band
#define ForwCal21MHz     (101.5)   // 21M band
#define ForwCal24MHz     (101.6)   // 24M band
#define ForwCal28MHz     (102.3)   // 28M band
#define ForwCal50MHz     (115.2)   // 50M band

#define ReflCalHF        (100)     // HF band
#define ReflCal19MHz     (91.0)    // 1.8M band
#define ReflCal35MHz     (93.0)    // 3.5M band
#define ReflCal7MHz      (95.0)    // 7.0M band 
#define ReflCal10MHz     (98.0)    // 10M band
#define ReflCal14MHz     (98.0)    // 14M band
#define ReflCal18MHz     (110.0)   // 18M band
#define ReflCal21MHz     (125.0)   // 21M band
#define ReflCal24MHz     (137.5)   // 24M band
#define ReflCal28MHz     (120.0)   // 28M band
#define ReflCal50MHz     (140.2)   // 50M band

#define pin_forward_v A0       // input (analog) - SWR sensor forward voltage
#define pin_reflected_v A1     // input (analog) - SWR sensor reverse voltage
#define BandSwitch (3)         // push button switch band change
#define DispSwitch (6)         // push button switch disp change

char* myStrings[]={" HF M", " 1.8M", " 3.5M", " 7.0M"," 10 M", " 14 M"," 18 M"," 21 M"," 24 M"," 28 M"," 50 M"};

byte BAND =(0);

unsigned long startTime;
unsigned long currentTime;
unsigned int ForwCal = 100 ;
unsigned int ReflCal = 100 ;

#include <LiquidCrystal.h>
#include <EEPROM.h>
#include <FreqCount.h>
LiquidCrystal lcd(7, 8, 9, 10, 11, 12); 

const unsigned long period = 400;

void setup() {
  BAND = EEPROM.read(1);{
    if (BAND == 0) {           // HF band set proper calibration constants
       ForwCal = ForwCalHF; ReflCal = ReflCalHF;}   
    if (BAND == 1) {           // 1.8M band BAND 6 と区別のため19MHzとする                   
       ForwCal = ForwCal19MHz; ReflCal = ReflCal19MHz;}                  
    if (BAND == 2) {           // 3.5M band 
       ForwCal = ForwCal35MHz; ReflCal = ReflCal35MHz;}                 
    if (BAND == 3) {           // 7.0M band
       ForwCal = ForwCal7MHz; ReflCal = ReflCal7MHz;}              
    if (BAND == 4) {           // 10M band
       ForwCal = ForwCal10MHz; ReflCal = ReflCal10MHz;}                  
    if (BAND == 5) {           // 14M band
       ForwCal = ForwCal14MHz; ReflCal = ReflCal14MHz;}              
    if (BAND == 6) {           // 18M band
       ForwCal = ForwCal18MHz; ReflCal = ReflCal18MHz;}                     
    if (BAND == 7) {           // 21M band
       ForwCal = ForwCal21MHz; ReflCal = ReflCal21MHz;}                                                
    if (BAND == 8) {           // 24M band
       ForwCal = ForwCal24MHz; ReflCal = ReflCal24MHz;}                                                
    if (BAND == 9) {           // 28M band
       ForwCal = ForwCal28MHz; ReflCal = ReflCal28MHz;}                  
    if (BAND == 10) {          // 50M band
       ForwCal = ForwCal50MHz; ReflCal = ReflCal50MHz;}             
  }       
    lcd.begin(20, 4);
    lcd.display();
    analogWrite(10,255);
    lcd.setCursor (0,1);
    lcd.print("   JA7FVT SENDAI");
    delay(500);
    lcd.clear();
    delay(300);
    lcd.home();
    lcd.setCursor (0,1);
    lcd.print("   JA7FVT SENDAI");
    delay(500);
    lcd.clear();
    delay(300);
    lcd.home();
    lcd.setCursor (0,1);
    lcd.print("   JA7FVT SENDAI");
    delay(500);
    lcd.clear();
    delay(300);
    lcd.home();
    lcd.setCursor (0,1);
    lcd.print("  POW & SWR");
    lcd.print(" METER");
    lcd.setCursor (5,3);
    lcd.print("Ver 2024/007/16");
    delay(3000);
    lcd.clear();
    delay(300);  
    initialize_native_pins();
    startTime = millis();
    FreqCount.begin(100);
    delay(100); 
  }

void initialize_native_pins(){    
    digitalWrite(pin_forward_v, LOW);
    pinMode(pin_forward_v, INPUT);
    digitalWrite(pin_reflected_v, LOW);
    pinMode(pin_reflected_v, INPUT);
    pinMode(BandSwitch, INPUT);     // if grounded  --> cycle through bands
    pinMode(DispSwitch, INPUT);     // if grounded  --> cycle through disp
  }

void check_Swr_calculate(){     
    forward_voltage = analogRead(float(pin_forward_v));
    reflected_voltage = analogRead(float(pin_reflected_v));
    forward_voltage = (map(forward_voltage,0,1023,0,5000))*ForwCal/100;
    reflected_voltage = (map(reflected_voltage,0,1023,0,5000))*ReflCal/100; 
      if (forward_voltage > reflected_voltage) {  
        if (reflected_voltage == 0) {SwrData = 100;} 
        if (forward_voltage > 0) {   
          Swr_Calc = sqrt((sq(reflected_voltage)) / (sq(forward_voltage)));
          Swr = (1 + Swr_Calc)/(1 - Swr_Calc);
          SwrData = Swr*100;  
            if (BAND == 3) {SwrData = Swr*100* 0.90;}                        // 7.0M bandで補正        
        if (SwrData < 100) {SwrData = 100;} 
        }
      }         
    forward_power = (sq((float(forward_voltage)))/80000/1.23); 
    Adj_forward_power = correct_Power(forward_power); 
    reflected_power = (sq((float(reflected_voltage)))/80000/1.23);  
    All_power = (Adj_forward_power) - (reflected_power);
    Eef_Calc = ((((Adj_forward_power)*4*(SwrData/100))/sq((SwrData/100) + 1))/(Adj_forward_power))*100;
  }

void check_Swr1(){
       check_Swr_calculate(); 
       check_Freq();
       lcd.clear();
       lcd.setCursor(0,0); 
       lcd.print("SWR");
    if (SwrData < 1){
       lcd.setCursor(4,0); 
       lcd.print(" -.--   ");}
    if (SwrData>= 1){
       lcd.setCursor(5,0);}
       lcd.print(String(SwrData/100,2)); 
       lcd.setCursor(0,1);
       lcd.print("Fwd");
    if (Adj_forward_power < 1){ 
       lcd.setCursor(4,1); 
       lcd.print("   ");
       lcd.setCursor(4,0); 
       lcd.print(" -.--   ");}
    if (Adj_forward_power >= 1){ 
       lcd.setCursor(4,1); 
       lcd.print("  ");} 
    if (Adj_forward_power >= 10){ 
       lcd.setCursor(4,1); 
       lcd.print(" ");}
    if (Adj_forward_power >= 100){ 
       lcd.setCursor(4,1);}
       lcd.print(Adj_forward_power); 
       lcd.setCursor(7,1); 
       lcd.print(" w"); 
       lcd.setCursor(0,2);
       lcd.print("Ref");
    if (reflected_power < 1){
       lcd.setCursor(4,2);
       lcd.print("   ");}
    if (reflected_power >= 1){  
       lcd.setCursor(4,2); 
       lcd.print("  ");} 
    if (reflected_power >= 10){  
       lcd.setCursor(4,2);
       lcd.print(" ");}
    if (reflected_power >= 100){  
       lcd.setCursor(4,2);}
       lcd.print(reflected_power);
       lcd.setCursor(7,2); 
       lcd.print(" w");
       lcd.setCursor(0,3); 
       lcd.print("PTX"); 
    if (All_power < 1){ 
       lcd.setCursor(4,3);
       lcd.print("   ");}
    if (All_power >= 1){
       lcd.setCursor(4,3);
       lcd.print("  ");} 
    if (All_power >= 10){
       lcd.setCursor(4,3);
       lcd.print(" ");}
    if (All_power >= 100){
       lcd.setCursor(4,3);}
       lcd.print(All_power);
       lcd.setCursor(7,3);
       lcd.print(" w");    
    if (Eef_Calc < 1) { 
       lcd.setCursor(15,3); 
       lcd.print("   ");}
    if (Eef_Calc >= 1) { 
       lcd.setCursor(15,3); 
       lcd.print("  ");} 
    if (Eef_Calc >= 10) { 
       lcd.setCursor(15,3);
       lcd.print(" ");}
    if (Eef_Calc >= 100) { 
       lcd.setCursor(15,3);}
       lcd.print(Eef_Calc); 
       lcd.setCursor(11,3); 
       lcd.print("Eef"); 
       lcd.setCursor(18,3); 
       lcd.print(" %");     
       lcd.setCursor(11,0);
       lcd.print("Band");  
       lcd.setCursor(15, 0);
       lcd.print(myStrings[BAND]);  
       check_Band();       
  }

void check_Swr2(){
       check_Swr_calculate(); 
       check_Freq();
       lcd.clear();
       lcd.setCursor(0,0); 
       lcd.print("PTX    "); 
    if (SwrData>= 1) {
       lcd.setCursor(5,1);}
       lcd.print(String(SwrData/100,2)); 
    if (All_power < 1) { 
       lcd.setCursor(4,0); 
       lcd.print("   ");
       lcd.setCursor(4,1); 
       lcd.print(" -.--       ");}      
    if (All_power >= 1) { 
       lcd.setCursor(4,0); 
       lcd.print("  ");} 
    if (All_power >= 10) { 
       lcd.setCursor(4,0); 
       lcd.print(" ");}
    if (All_power >= 100) { 
       lcd.setCursor(4,0);}
       lcd.print(All_power); 
       lcd.setCursor(7,0); 
       lcd.print(" w   "); 
       lcd.setCursor(0,1); 
       lcd.print("SWR");        
       lcd.setCursor(16,0);                                     
       lcd.print("Band");  
       lcd.setCursor(15, 1);
       lcd.print(myStrings[BAND]);     
       int i;
    if (All_power <= 125) { 
       lcd.setCursor(10,0); 
       lcd.print(">125w"); 
       int Powbar = min(All_power/5 ,20);
       lcd.setCursor(0,2); 
       lcd.print("____________________");
       for (i=0;i<min(Powbar,20);i++) {
       lcd.setCursor(0+i,2);
       lcd.print(FF);    
       }
     }
    if (All_power >= 125) { 
       lcd.setCursor(10,0); 
       lcd.print("<125w");      
       int Powbar = min(All_power/10 ,20);
       lcd.setCursor(0,2); 
       lcd.print("____________________");
       for (i=0;i<min(Powbar,20);i++) {
       lcd.setCursor(0+i,2);
       lcd.print(FF);    
       }
     }
     int j;
     int Swrbar = min(((SwrData/100)-1)*10 ,20);
       lcd.setCursor(0,3); 
       lcd.print("____________________");
       for (j=0;j<min(Swrbar,20);j++) {
       lcd.setCursor(0+j,3);
    if (All_power < 1) { 
       lcd.setCursor(0,3); 
       lcd.print("____________________");}
       lcd.print(FF); 
       lcd.setCursor(0,0); 
       lcd.print("PTX");    
    }  
       check_Band();      
}

void check_Volt(){
       check_Swr_calculate(); 
       lcd.clear();
       lcd.setCursor(0,0); 
       lcd.print("Fwd(v)"); 
       lcd.setCursor(7,0); 
       lcd.print(forward_voltage/1000,3);
       lcd.setCursor(13,0); 
       lcd.print("v");      
       lcd.setCursor(0,1); 
       lcd.print("Ref(v)");        
       lcd.setCursor(7,1); 
       lcd.print(reflected_voltage/1000,3); 
       lcd.setCursor(7,2); 
       lcd.print(String(SwrData/100,2));
    if (Adj_forward_power < 1){ 
       lcd.setCursor(7,2); 
       lcd.print("-.--");}
       lcd.setCursor(0,2); 
       lcd.print("SWR"); 
       lcd.setCursor(13,1); 
       lcd.print("v"); 
       lcd.setCursor(16,0);                                     
       lcd.print("Band");  
       lcd.setCursor(15, 1);
       lcd.print(myStrings[BAND]);      
       check_Freq();
       check_Band();
  }

void check_Band(){ 
    if (digitalRead (BandSwitch) == 0) {                        // BAND cycle pushbutton depressed           
       delay (500);                                                     
    if (digitalRead (BandSwitch) == 1) {                        // released 
       delay(10);  
                                                        
    BAND = BAND + 1;                              
    if (BAND >= 11) BAND = 0;                                   // set 0 if HF is enabled !  
       delay(5);                                                // チャタリング防止                           
       EEPROM.write(1,BAND);                                    // store new mode 
    if (BAND == 0) {           // HF band set proper calibration constants
       ForwCal = ForwCalHF; ReflCal = ReflCalHF;}  
       delay(5);
    if (BAND == 1) {           // 1.8M band BAND 6 と区別のため19MHzとする                    
       ForwCal = ForwCal19MHz; ReflCal = ReflCal19MHz;}      
       delay(5);
    if (BAND == 2) {           // 3.5M band 
       ForwCal = ForwCal35MHz; ReflCal = ReflCal35MHz;}   
       delay(5);
    if (BAND == 3) {           // 7.0M band
       ForwCal = ForwCal7MHz; ReflCal = ReflCal7MHz;}     
       delay(5);
    if (BAND == 4) {           // 10M band
       ForwCal = ForwCal10MHz; ReflCal = ReflCal10MHz;}      
       delay(5);
    if (BAND == 5) {           // 14M band
       ForwCal = ForwCal14MHz; ReflCal = ReflCal14MHz;}         
       delay(5);
    if (BAND == 6) {           // 18M band
       ForwCal = ForwCal18MHz; ReflCal = ReflCal18MHz;}    
       delay(5);
    if (BAND == 7) {           // 21M band
       ForwCal = ForwCal21MHz; ReflCal = ReflCal21MHz;}       
       delay(5);
    if (BAND == 8) {           // 24M band
       ForwCal = ForwCal24MHz; ReflCal = ReflCal24MHz;}    
       delay(5);
    if (BAND == 9) {           // 28M band
       ForwCal = ForwCal28MHz; ReflCal = ReflCal28MHz;}       
       delay(5);
    if (BAND == 10) {          // 50M band
       ForwCal = ForwCal50MHz; ReflCal = ReflCal50MHz;}       
       delay(5);
    }
   }
 }

 void check_Freq(){  
    byte oldTCCR0A = TCCR0A;
    byte oldTCCR0B = TCCR0B;
    TCCR0A = 0;  // stop timer 0
    TCCR0B = 0;    
    if (FreqCount.available()) {
      float count = FreqCount.read();
      float Freq_D = (count*16/100*1.000897);
    TCCR0A = oldTCCR0A;
    TCCR0B = oldTCCR0B;

       if((Freq_D>1810) && (Freq_D<1912.5)) {BAND = 1;}       // 1.8M band
       else if((Freq_D>3450) && (Freq_D<3855)) {BAND = 2;}    // 3.5M band
       else if((Freq_D>6950) && (Freq_D<7250)) {BAND = 3;}    // 7.0M band
       else if((Freq_D>9950) && (Freq_D<10200)) {BAND = 4;}   // 10M band
       else if((Freq_D>13950) && (Freq_D<14400)) {BAND = 5;}  // 14M band
       else if((Freq_D>18018) && (Freq_D<18218)) {BAND = 6;}  // 18M band
       else if((Freq_D>20950) && (Freq_D<21500)) {BAND = 7;}  // 21M band
       else if((Freq_D>24840) && (Freq_D<25040)) {BAND = 8;}  // 24M band
       else if((Freq_D>27950) && (Freq_D<29750)) {BAND = 9;}  // 28M band
       else if((Freq_D>49950) && (Freq_D<52050)) {BAND = 10;} // 50M band
  
    if (BAND == 0) {           // HF band set proper calibration constants
       ForwCal = ForwCalHF; ReflCal = ReflCalHF;}   
    if (BAND == 1) {           // 1.8M band BAND 6 と区別のため19MHzとする                   
       ForwCal = ForwCal19MHz; ReflCal = ReflCal19MHz;}                  
    if (BAND == 2) {           // 3.5M band 
       ForwCal = ForwCal35MHz; ReflCal = ReflCal35MHz;}                 
    if (BAND == 3) {           // 7.0M band
       ForwCal = ForwCal7MHz; ReflCal = ReflCal7MHz;}              
    if (BAND == 4) {           // 10M band
       ForwCal = ForwCal10MHz; ReflCal = ReflCal10MHz;}                  
    if (BAND == 5) {           // 14M band
       ForwCal = ForwCal14MHz; ReflCal = ReflCal14MHz;}              
    if (BAND == 6) {           // 18M band
       ForwCal = ForwCal18MHz; ReflCal = ReflCal18MHz;}                     
    if (BAND == 7) {           // 21M band
       ForwCal = ForwCal21MHz; ReflCal = ReflCal21MHz;}                                                
    if (BAND == 8) {           // 24M band
       ForwCal = ForwCal24MHz; ReflCal = ReflCal24MHz;}                                                
    if (BAND == 9) {           // 28M band
       ForwCal = ForwCal28MHz; ReflCal = ReflCal28MHz;}                  
    if (BAND == 10) {          // 50M band
       ForwCal = ForwCal50MHz; ReflCal = ReflCal50MHz;}  
       lcd.setCursor(0, 3);           
       lcd.print("TX freq");
       lcd.setCursor(9,3);
       lcd.print(String(Freq_D/1000,3));
       lcd.print(" MHz");                      
       EEPROM.write(1,BAND);   // store new mode        
    }
 }
 
 void loop() {
    currentTime = millis();
        if (currentTime - startTime >= period)
       {
        DispMode = 0; for (int ButonPush = 0 ;; ButonPush ++) {  // 繰り返しの設定    
       delay(5);                                                 // チャタリング防止    
    if (digitalRead(6) == LOW) {                                 // タクトスイッチが押されたことを検知      
       DispMode = DispMode + 1;                                  // 状態を進める      
    if (DispMode > 2)                                            // 3水準なので2の次は0        
       DispMode = 0;      
       delay(5);      
    if (ButonPush > 30)                                          // 繰り返し動作の状態の確認        
       ButonPush = 0;      
       delay(5);     
    while (digitalRead(6) == LOW) {}                             // タクトスイッチが押されたことを検知    
     }
    if (DispMode == 0) {                                         // 第一のDISP状態      
       currentTime = millis();
    if (currentTime - startTime >= period) {
       check_Swr2();
       startTime = currentTime;
     }  
     }   
    if (DispMode == 1) {                                         // 第二のDISP状態 
       currentTime = millis();
    if (currentTime - startTime >= period) {     
       lcd.clear();
       check_Swr1();
       startTime = currentTime;
     }
     } 
    if (DispMode == 2) {                                         // 第3三のDISP状態 
       currentTime = millis();   
    if (currentTime - startTime >= period) {                                               
       lcd.clear();
       check_Volt();
       startTime = currentTime;
     } 
     }   
   } //forのend 
  }
       delay(5);
}